#ifndef QTMESSAGE_H
#define QTMESSAGE_H
#include <QMetaType>
#include <QVariant>

const int MAXNUM=255;
enum MessageType
{
    ePlcSignal=0
    ,eMeasure
};


typedef struct QTMESSAGEDATA
{
    MessageType msg_type;
    unsigned short plc_data[MAXNUM];
    int signal_size;
    // measure result
    int OK;
    double x,y,c;
    double l,w,h;
    double d;
    int position_id;
    int stat;
    short lasers_id;
    char project_dir[255];
    char time_str[255];
}QtMessageData;

Q_DECLARE_METATYPE(QTMESSAGEDATA)


#endif // QTMESSAGE_H
