#pragma once
#include "LivoxLaser.h"
#include "livox_def.h"
#include "livox_sdk.h"
#include <map>
class CLivoxMid100Laser : public CLivoxLaser
{

public:
	CLivoxMid100Laser(int id, Automatic::stLaserCalibParam laser_param);
	~CLivoxMid100Laser();
	virtual bool Start();

protected:
	virtual bool IsScanComplete();
	virtual void UpdataHandle();

protected:
	uint8_t		m_handle1;
	uint8_t		m_handle2;
	uint8_t		m_handle3;
};


