#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QListWidget>
#include <QPushButton>

#include <QVariant>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    QString blue_style = "background-color: qradialgradient(spread:pad, cx:0.5, cy:0.5, radius:0.5, fx:0.5, fy:0.505682, stop:0.9 rgba(0, 0, 255, 255), stop:1 rgba(255, 255, 255, 0));";
    QString red_style = "background-color: qradialgradient(spread:pad, cx:0.5, cy:0.5, radius:0.5, fx:0.5, fy:0.505682, stop:0.9 rgba(255, 0, 0, 255), stop:1 rgba(255, 255, 255, 0));";
    QString green_style = "background-color: qradialgradient(spread:pad, cx:0.5, cy:0.5, radius:0.5, fx:0.5, fy:0.505682, stop:0.9 rgba(0, 255, 0, 255), stop:1 rgba(255, 255, 255, 0));";
    int label_color = 0;
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
protected:
    void AddLog(std::string log);
private slots:
    void on_m_test_btn_clicked();
    void on_m_add_clicked();

private slots:
    void ProcessSlot(QVariant data);

    //void on_m_add_clicked(bool checked);

    void on_m_signal_test_clicked();

private:
    QPushButton* m_test_button;

private:
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
